/**
 *    Copyright (C) 2015 MongoDB Inc.
 *
 *    This program is free software: you can redistribute it and/or  modify
 *    it under the terms of the GNU Affero General Public License, version 3,
 *    as published by the Free Software Foundation.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Affero General Public License for more details.
 *
 *    You should have received a copy of the GNU Affero General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *    As a special exception, the copyright holders give permission to link the
 *    code of portions of this program with the OpenSSL library under certain
 *    conditions as described in each individual source file and distribute
 *    linked combinations including the program with the OpenSSL library. You
 *    must comply with the GNU Affero General Public License in all respects for
 *    all of the code used other than as permitted herein. If you modify file(s)
 *    with this exception, you may extend this exception to your version of the
 *    file(s), but you are not obligated to do so. If you do not wish to do so,
 *    delete this exception statement from your version. If you delete this
 *    exception statement from all source files in the program, then also delete
 *    it in the license file.
 *
 *    THIS IS A GENERATED FILE, DO NOT MODIFY.
 */

#include "mongo/db/fts/unicode/codepoints.h"

namespace mongo {
namespace unicode {

bool codepointIsDiacritic(char32_t codepoint) {
    switch (codepoint) {
    case 0x5e: return true;
    case 0x60: return true;
    case 0xa8: return true;
    case 0xaf: return true;
    case 0xb4: return true;
    case 0xb7: return true;
    case 0xb8: return true;
    case 0x2b0: return true;
    case 0x2b1: return true;
    case 0x2b2: return true;
    case 0x2b3: return true;
    case 0x2b4: return true;
    case 0x2b5: return true;
    case 0x2b6: return true;
    case 0x2b7: return true;
    case 0x2b8: return true;
    case 0x2b9: return true;
    case 0x2ba: return true;
    case 0x2bb: return true;
    case 0x2bc: return true;
    case 0x2bd: return true;
    case 0x2be: return true;
    case 0x2bf: return true;
    case 0x2c0: return true;
    case 0x2c1: return true;
    case 0x2c2: return true;
    case 0x2c3: return true;
    case 0x2c4: return true;
    case 0x2c5: return true;
    case 0x2c6: return true;
    case 0x2c7: return true;
    case 0x2c8: return true;
    case 0x2c9: return true;
    case 0x2ca: return true;
    case 0x2cb: return true;
    case 0x2cc: return true;
    case 0x2cd: return true;
    case 0x2ce: return true;
    case 0x2cf: return true;
    case 0x2d0: return true;
    case 0x2d1: return true;
    case 0x2d2: return true;
    case 0x2d3: return true;
    case 0x2d4: return true;
    case 0x2d5: return true;
    case 0x2d6: return true;
    case 0x2d7: return true;
    case 0x2d8: return true;
    case 0x2d9: return true;
    case 0x2da: return true;
    case 0x2db: return true;
    case 0x2dc: return true;
    case 0x2dd: return true;
    case 0x2de: return true;
    case 0x2df: return true;
    case 0x2e0: return true;
    case 0x2e1: return true;
    case 0x2e2: return true;
    case 0x2e3: return true;
    case 0x2e4: return true;
    case 0x2e5: return true;
    case 0x2e6: return true;
    case 0x2e7: return true;
    case 0x2e8: return true;
    case 0x2e9: return true;
    case 0x2ea: return true;
    case 0x2eb: return true;
    case 0x2ec: return true;
    case 0x2ed: return true;
    case 0x2ee: return true;
    case 0x2ef: return true;
    case 0x2f0: return true;
    case 0x2f1: return true;
    case 0x2f2: return true;
    case 0x2f3: return true;
    case 0x2f4: return true;
    case 0x2f5: return true;
    case 0x2f6: return true;
    case 0x2f7: return true;
    case 0x2f8: return true;
    case 0x2f9: return true;
    case 0x2fa: return true;
    case 0x2fb: return true;
    case 0x2fc: return true;
    case 0x2fd: return true;
    case 0x2fe: return true;
    case 0x2ff: return true;
    case 0x300: return true;
    case 0x301: return true;
    case 0x302: return true;
    case 0x303: return true;
    case 0x304: return true;
    case 0x305: return true;
    case 0x306: return true;
    case 0x307: return true;
    case 0x308: return true;
    case 0x309: return true;
    case 0x30a: return true;
    case 0x30b: return true;
    case 0x30c: return true;
    case 0x30d: return true;
    case 0x30e: return true;
    case 0x30f: return true;
    case 0x310: return true;
    case 0x311: return true;
    case 0x312: return true;
    case 0x313: return true;
    case 0x314: return true;
    case 0x315: return true;
    case 0x316: return true;
    case 0x317: return true;
    case 0x318: return true;
    case 0x319: return true;
    case 0x31a: return true;
    case 0x31b: return true;
    case 0x31c: return true;
    case 0x31d: return true;
    case 0x31e: return true;
    case 0x31f: return true;
    case 0x320: return true;
    case 0x321: return true;
    case 0x322: return true;
    case 0x323: return true;
    case 0x324: return true;
    case 0x325: return true;
    case 0x326: return true;
    case 0x327: return true;
    case 0x328: return true;
    case 0x329: return true;
    case 0x32a: return true;
    case 0x32b: return true;
    case 0x32c: return true;
    case 0x32d: return true;
    case 0x32e: return true;
    case 0x32f: return true;
    case 0x330: return true;
    case 0x331: return true;
    case 0x332: return true;
    case 0x333: return true;
    case 0x334: return true;
    case 0x335: return true;
    case 0x336: return true;
    case 0x337: return true;
    case 0x338: return true;
    case 0x339: return true;
    case 0x33a: return true;
    case 0x33b: return true;
    case 0x33c: return true;
    case 0x33d: return true;
    case 0x33e: return true;
    case 0x33f: return true;
    case 0x340: return true;
    case 0x341: return true;
    case 0x342: return true;
    case 0x343: return true;
    case 0x344: return true;
    case 0x345: return true;
    case 0x346: return true;
    case 0x347: return true;
    case 0x348: return true;
    case 0x349: return true;
    case 0x34a: return true;
    case 0x34b: return true;
    case 0x34c: return true;
    case 0x34d: return true;
    case 0x34e: return true;
    case 0x350: return true;
    case 0x351: return true;
    case 0x352: return true;
    case 0x353: return true;
    case 0x354: return true;
    case 0x355: return true;
    case 0x356: return true;
    case 0x357: return true;
    case 0x35d: return true;
    case 0x35e: return true;
    case 0x35f: return true;
    case 0x360: return true;
    case 0x361: return true;
    case 0x362: return true;
    case 0x374: return true;
    case 0x375: return true;
    case 0x37a: return true;
    case 0x384: return true;
    case 0x385: return true;
    case 0x483: return true;
    case 0x484: return true;
    case 0x485: return true;
    case 0x486: return true;
    case 0x487: return true;
    case 0x559: return true;
    case 0x591: return true;
    case 0x592: return true;
    case 0x593: return true;
    case 0x594: return true;
    case 0x595: return true;
    case 0x596: return true;
    case 0x597: return true;
    case 0x598: return true;
    case 0x599: return true;
    case 0x59a: return true;
    case 0x59b: return true;
    case 0x59c: return true;
    case 0x59d: return true;
    case 0x59e: return true;
    case 0x59f: return true;
    case 0x5a0: return true;
    case 0x5a1: return true;
    case 0x5a3: return true;
    case 0x5a4: return true;
    case 0x5a5: return true;
    case 0x5a6: return true;
    case 0x5a7: return true;
    case 0x5a8: return true;
    case 0x5a9: return true;
    case 0x5aa: return true;
    case 0x5ab: return true;
    case 0x5ac: return true;
    case 0x5ad: return true;
    case 0x5ae: return true;
    case 0x5af: return true;
    case 0x5b0: return true;
    case 0x5b1: return true;
    case 0x5b2: return true;
    case 0x5b3: return true;
    case 0x5b4: return true;
    case 0x5b5: return true;
    case 0x5b6: return true;
    case 0x5b7: return true;
    case 0x5b8: return true;
    case 0x5b9: return true;
    case 0x5ba: return true;
    case 0x5bb: return true;
    case 0x5bc: return true;
    case 0x5bd: return true;
    case 0x5bf: return true;
    case 0x5c1: return true;
    case 0x5c2: return true;
    case 0x5c4: return true;
    case 0x64b: return true;
    case 0x64c: return true;
    case 0x64d: return true;
    case 0x64e: return true;
    case 0x64f: return true;
    case 0x650: return true;
    case 0x651: return true;
    case 0x652: return true;
    case 0x657: return true;
    case 0x658: return true;
    case 0x6df: return true;
    case 0x6e0: return true;
    case 0x6e5: return true;
    case 0x6e6: return true;
    case 0x6ea: return true;
    case 0x6eb: return true;
    case 0x6ec: return true;
    case 0x730: return true;
    case 0x731: return true;
    case 0x732: return true;
    case 0x733: return true;
    case 0x734: return true;
    case 0x735: return true;
    case 0x736: return true;
    case 0x737: return true;
    case 0x738: return true;
    case 0x739: return true;
    case 0x73a: return true;
    case 0x73b: return true;
    case 0x73c: return true;
    case 0x73d: return true;
    case 0x73e: return true;
    case 0x73f: return true;
    case 0x740: return true;
    case 0x741: return true;
    case 0x742: return true;
    case 0x743: return true;
    case 0x744: return true;
    case 0x745: return true;
    case 0x746: return true;
    case 0x747: return true;
    case 0x748: return true;
    case 0x749: return true;
    case 0x74a: return true;
    case 0x7a6: return true;
    case 0x7a7: return true;
    case 0x7a8: return true;
    case 0x7a9: return true;
    case 0x7aa: return true;
    case 0x7ab: return true;
    case 0x7ac: return true;
    case 0x7ad: return true;
    case 0x7ae: return true;
    case 0x7af: return true;
    case 0x7b0: return true;
    case 0x7eb: return true;
    case 0x7ec: return true;
    case 0x7ed: return true;
    case 0x7ee: return true;
    case 0x7ef: return true;
    case 0x7f0: return true;
    case 0x7f1: return true;
    case 0x7f2: return true;
    case 0x7f3: return true;
    case 0x7f4: return true;
    case 0x7f5: return true;
    case 0x818: return true;
    case 0x819: return true;
    case 0x8e3: return true;
    case 0x8e4: return true;
    case 0x8e5: return true;
    case 0x8e6: return true;
    case 0x8e7: return true;
    case 0x8e8: return true;
    case 0x8e9: return true;
    case 0x8ea: return true;
    case 0x8eb: return true;
    case 0x8ec: return true;
    case 0x8ed: return true;
    case 0x8ee: return true;
    case 0x8ef: return true;
    case 0x8f0: return true;
    case 0x8f1: return true;
    case 0x8f2: return true;
    case 0x8f3: return true;
    case 0x8f4: return true;
    case 0x8f5: return true;
    case 0x8f6: return true;
    case 0x8f7: return true;
    case 0x8f8: return true;
    case 0x8f9: return true;
    case 0x8fa: return true;
    case 0x8fb: return true;
    case 0x8fc: return true;
    case 0x8fd: return true;
    case 0x8fe: return true;
    case 0x93c: return true;
    case 0x94d: return true;
    case 0x951: return true;
    case 0x952: return true;
    case 0x953: return true;
    case 0x954: return true;
    case 0x971: return true;
    case 0x9bc: return true;
    case 0x9cd: return true;
    case 0xa3c: return true;
    case 0xa4d: return true;
    case 0xabc: return true;
    case 0xacd: return true;
    case 0xb3c: return true;
    case 0xb4d: return true;
    case 0xbcd: return true;
    case 0xc4d: return true;
    case 0xcbc: return true;
    case 0xccd: return true;
    case 0xd4d: return true;
    case 0xdca: return true;
    case 0xe47: return true;
    case 0xe48: return true;
    case 0xe49: return true;
    case 0xe4a: return true;
    case 0xe4b: return true;
    case 0xe4c: return true;
    case 0xe4e: return true;
    case 0xec8: return true;
    case 0xec9: return true;
    case 0xeca: return true;
    case 0xecb: return true;
    case 0xecc: return true;
    case 0xf18: return true;
    case 0xf19: return true;
    case 0xf35: return true;
    case 0xf37: return true;
    case 0xf39: return true;
    case 0xf3e: return true;
    case 0xf3f: return true;
    case 0xf82: return true;
    case 0xf83: return true;
    case 0xf84: return true;
    case 0xf86: return true;
    case 0xf87: return true;
    case 0xfc6: return true;
    case 0x1037: return true;
    case 0x1039: return true;
    case 0x103a: return true;
    case 0x1087: return true;
    case 0x1088: return true;
    case 0x1089: return true;
    case 0x108a: return true;
    case 0x108b: return true;
    case 0x108c: return true;
    case 0x108d: return true;
    case 0x108f: return true;
    case 0x109a: return true;
    case 0x109b: return true;
    case 0x17c9: return true;
    case 0x17ca: return true;
    case 0x17cb: return true;
    case 0x17cc: return true;
    case 0x17cd: return true;
    case 0x17ce: return true;
    case 0x17cf: return true;
    case 0x17d0: return true;
    case 0x17d1: return true;
    case 0x17d2: return true;
    case 0x17d3: return true;
    case 0x17dd: return true;
    case 0x1939: return true;
    case 0x193a: return true;
    case 0x193b: return true;
    case 0x1a75: return true;
    case 0x1a76: return true;
    case 0x1a77: return true;
    case 0x1a78: return true;
    case 0x1a79: return true;
    case 0x1a7a: return true;
    case 0x1a7b: return true;
    case 0x1a7c: return true;
    case 0x1a7f: return true;
    case 0x1ab0: return true;
    case 0x1ab1: return true;
    case 0x1ab2: return true;
    case 0x1ab3: return true;
    case 0x1ab4: return true;
    case 0x1ab5: return true;
    case 0x1ab6: return true;
    case 0x1ab7: return true;
    case 0x1ab8: return true;
    case 0x1ab9: return true;
    case 0x1aba: return true;
    case 0x1abb: return true;
    case 0x1abc: return true;
    case 0x1abd: return true;
    case 0x1b34: return true;
    case 0x1b44: return true;
    case 0x1b6b: return true;
    case 0x1b6c: return true;
    case 0x1b6d: return true;
    case 0x1b6e: return true;
    case 0x1b6f: return true;
    case 0x1b70: return true;
    case 0x1b71: return true;
    case 0x1b72: return true;
    case 0x1b73: return true;
    case 0x1baa: return true;
    case 0x1bab: return true;
    case 0x1c36: return true;
    case 0x1c37: return true;
    case 0x1c78: return true;
    case 0x1c79: return true;
    case 0x1c7a: return true;
    case 0x1c7b: return true;
    case 0x1c7c: return true;
    case 0x1c7d: return true;
    case 0x1cd0: return true;
    case 0x1cd1: return true;
    case 0x1cd2: return true;
    case 0x1cd3: return true;
    case 0x1cd4: return true;
    case 0x1cd5: return true;
    case 0x1cd6: return true;
    case 0x1cd7: return true;
    case 0x1cd8: return true;
    case 0x1cd9: return true;
    case 0x1cda: return true;
    case 0x1cdb: return true;
    case 0x1cdc: return true;
    case 0x1cdd: return true;
    case 0x1cde: return true;
    case 0x1cdf: return true;
    case 0x1ce0: return true;
    case 0x1ce1: return true;
    case 0x1ce2: return true;
    case 0x1ce3: return true;
    case 0x1ce4: return true;
    case 0x1ce5: return true;
    case 0x1ce6: return true;
    case 0x1ce7: return true;
    case 0x1ce8: return true;
    case 0x1ced: return true;
    case 0x1cf4: return true;
    case 0x1cf8: return true;
    case 0x1cf9: return true;
    case 0x1d2c: return true;
    case 0x1d2d: return true;
    case 0x1d2e: return true;
    case 0x1d2f: return true;
    case 0x1d30: return true;
    case 0x1d31: return true;
    case 0x1d32: return true;
    case 0x1d33: return true;
    case 0x1d34: return true;
    case 0x1d35: return true;
    case 0x1d36: return true;
    case 0x1d37: return true;
    case 0x1d38: return true;
    case 0x1d39: return true;
    case 0x1d3a: return true;
    case 0x1d3b: return true;
    case 0x1d3c: return true;
    case 0x1d3d: return true;
    case 0x1d3e: return true;
    case 0x1d3f: return true;
    case 0x1d40: return true;
    case 0x1d41: return true;
    case 0x1d42: return true;
    case 0x1d43: return true;
    case 0x1d44: return true;
    case 0x1d45: return true;
    case 0x1d46: return true;
    case 0x1d47: return true;
    case 0x1d48: return true;
    case 0x1d49: return true;
    case 0x1d4a: return true;
    case 0x1d4b: return true;
    case 0x1d4c: return true;
    case 0x1d4d: return true;
    case 0x1d4e: return true;
    case 0x1d4f: return true;
    case 0x1d50: return true;
    case 0x1d51: return true;
    case 0x1d52: return true;
    case 0x1d53: return true;
    case 0x1d54: return true;
    case 0x1d55: return true;
    case 0x1d56: return true;
    case 0x1d57: return true;
    case 0x1d58: return true;
    case 0x1d59: return true;
    case 0x1d5a: return true;
    case 0x1d5b: return true;
    case 0x1d5c: return true;
    case 0x1d5d: return true;
    case 0x1d5e: return true;
    case 0x1d5f: return true;
    case 0x1d60: return true;
    case 0x1d61: return true;
    case 0x1d62: return true;
    case 0x1d63: return true;
    case 0x1d64: return true;
    case 0x1d65: return true;
    case 0x1d66: return true;
    case 0x1d67: return true;
    case 0x1d68: return true;
    case 0x1d69: return true;
    case 0x1d6a: return true;
    case 0x1dc4: return true;
    case 0x1dc5: return true;
    case 0x1dc6: return true;
    case 0x1dc7: return true;
    case 0x1dc8: return true;
    case 0x1dc9: return true;
    case 0x1dca: return true;
    case 0x1dcb: return true;
    case 0x1dcc: return true;
    case 0x1dcd: return true;
    case 0x1dce: return true;
    case 0x1dcf: return true;
    case 0x1df5: return true;
    case 0x1dfd: return true;
    case 0x1dfe: return true;
    case 0x1dff: return true;
    case 0x1fbd: return true;
    case 0x1fbf: return true;
    case 0x1fc0: return true;
    case 0x1fc1: return true;
    case 0x1fcd: return true;
    case 0x1fce: return true;
    case 0x1fcf: return true;
    case 0x1fdd: return true;
    case 0x1fde: return true;
    case 0x1fdf: return true;
    case 0x1fed: return true;
    case 0x1fee: return true;
    case 0x1fef: return true;
    case 0x1ffd: return true;
    case 0x1ffe: return true;
    case 0x2cef: return true;
    case 0x2cf0: return true;
    case 0x2cf1: return true;
    case 0x2e2f: return true;
    case 0x302a: return true;
    case 0x302b: return true;
    case 0x302c: return true;
    case 0x302d: return true;
    case 0x302e: return true;
    case 0x302f: return true;
    case 0x3099: return true;
    case 0x309a: return true;
    case 0x309b: return true;
    case 0x309c: return true;
    case 0x30fc: return true;
    case 0xa66f: return true;
    case 0xa67c: return true;
    case 0xa67d: return true;
    case 0xa67f: return true;
    case 0xa69c: return true;
    case 0xa69d: return true;
    case 0xa6f0: return true;
    case 0xa6f1: return true;
    case 0xa717: return true;
    case 0xa718: return true;
    case 0xa719: return true;
    case 0xa71a: return true;
    case 0xa71b: return true;
    case 0xa71c: return true;
    case 0xa71d: return true;
    case 0xa71e: return true;
    case 0xa71f: return true;
    case 0xa720: return true;
    case 0xa721: return true;
    case 0xa788: return true;
    case 0xa7f8: return true;
    case 0xa7f9: return true;
    case 0xa8c4: return true;
    case 0xa8e0: return true;
    case 0xa8e1: return true;
    case 0xa8e2: return true;
    case 0xa8e3: return true;
    case 0xa8e4: return true;
    case 0xa8e5: return true;
    case 0xa8e6: return true;
    case 0xa8e7: return true;
    case 0xa8e8: return true;
    case 0xa8e9: return true;
    case 0xa8ea: return true;
    case 0xa8eb: return true;
    case 0xa8ec: return true;
    case 0xa8ed: return true;
    case 0xa8ee: return true;
    case 0xa8ef: return true;
    case 0xa8f0: return true;
    case 0xa8f1: return true;
    case 0xa92b: return true;
    case 0xa92c: return true;
    case 0xa92d: return true;
    case 0xa92e: return true;
    case 0xa953: return true;
    case 0xa9b3: return true;
    case 0xa9c0: return true;
    case 0xa9e5: return true;
    case 0xaa7b: return true;
    case 0xaa7c: return true;
    case 0xaa7d: return true;
    case 0xaabf: return true;
    case 0xaac0: return true;
    case 0xaac1: return true;
    case 0xaac2: return true;
    case 0xaaf6: return true;
    case 0xab5b: return true;
    case 0xab5c: return true;
    case 0xab5d: return true;
    case 0xab5e: return true;
    case 0xab5f: return true;
    case 0xabec: return true;
    case 0xabed: return true;
    case 0xfb1e: return true;
    case 0xfe20: return true;
    case 0xfe21: return true;
    case 0xfe22: return true;
    case 0xfe23: return true;
    case 0xfe24: return true;
    case 0xfe25: return true;
    case 0xfe26: return true;
    case 0xfe27: return true;
    case 0xfe28: return true;
    case 0xfe29: return true;
    case 0xfe2a: return true;
    case 0xfe2b: return true;
    case 0xfe2c: return true;
    case 0xfe2d: return true;
    case 0xfe2e: return true;
    case 0xfe2f: return true;
    case 0xff3e: return true;
    case 0xff40: return true;
    case 0xff70: return true;
    case 0xff9e: return true;
    case 0xff9f: return true;
    case 0xffe3: return true;
    case 0x102e0: return true;
    case 0x10ae5: return true;
    case 0x10ae6: return true;
    case 0x110b9: return true;
    case 0x110ba: return true;
    case 0x11133: return true;
    case 0x11134: return true;
    case 0x11173: return true;
    case 0x111c0: return true;
    case 0x111ca: return true;
    case 0x111cb: return true;
    case 0x111cc: return true;
    case 0x11235: return true;
    case 0x11236: return true;
    case 0x112e9: return true;
    case 0x112ea: return true;
    case 0x1133c: return true;
    case 0x1134d: return true;
    case 0x11366: return true;
    case 0x11367: return true;
    case 0x11368: return true;
    case 0x11369: return true;
    case 0x1136a: return true;
    case 0x1136b: return true;
    case 0x1136c: return true;
    case 0x11370: return true;
    case 0x11371: return true;
    case 0x11372: return true;
    case 0x11373: return true;
    case 0x11374: return true;
    case 0x114c2: return true;
    case 0x114c3: return true;
    case 0x115bf: return true;
    case 0x115c0: return true;
    case 0x1163f: return true;
    case 0x116b6: return true;
    case 0x116b7: return true;
    case 0x1172b: return true;
    case 0x16af0: return true;
    case 0x16af1: return true;
    case 0x16af2: return true;
    case 0x16af3: return true;
    case 0x16af4: return true;
    case 0x16f8f: return true;
    case 0x16f90: return true;
    case 0x16f91: return true;
    case 0x16f92: return true;
    case 0x16f93: return true;
    case 0x16f94: return true;
    case 0x16f95: return true;
    case 0x16f96: return true;
    case 0x16f97: return true;
    case 0x16f98: return true;
    case 0x16f99: return true;
    case 0x16f9a: return true;
    case 0x16f9b: return true;
    case 0x16f9c: return true;
    case 0x16f9d: return true;
    case 0x16f9e: return true;
    case 0x16f9f: return true;
    case 0x1d167: return true;
    case 0x1d168: return true;
    case 0x1d169: return true;
    case 0x1d16d: return true;
    case 0x1d16e: return true;
    case 0x1d16f: return true;
    case 0x1d170: return true;
    case 0x1d171: return true;
    case 0x1d172: return true;
    case 0x1d17b: return true;
    case 0x1d17c: return true;
    case 0x1d17d: return true;
    case 0x1d17e: return true;
    case 0x1d17f: return true;
    case 0x1d180: return true;
    case 0x1d181: return true;
    case 0x1d182: return true;
    case 0x1d185: return true;
    case 0x1d186: return true;
    case 0x1d187: return true;
    case 0x1d188: return true;
    case 0x1d189: return true;
    case 0x1d18a: return true;
    case 0x1d18b: return true;
    case 0x1d1aa: return true;
    case 0x1d1ab: return true;
    case 0x1d1ac: return true;
    case 0x1d1ad: return true;
    case 0x1e8d0: return true;
    case 0x1e8d1: return true;
    case 0x1e8d2: return true;
    case 0x1e8d3: return true;
    case 0x1e8d4: return true;
    case 0x1e8d5: return true;
    case 0x1e8d6: return true;
    default: return false;
    }
}
} //  namespace unicode
} //  namespace mongo
