/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/fedora --target_arch aarch64 --header build/fedora/mongo/db/repl/apply_ops_gen.h --output build/fedora/mongo/db/repl/apply_ops_gen.cpp src/mongo/db/repl/apply_ops.idl
 */

#include "mongo/platform/basic.h"

#include "mongo/db/repl/apply_ops_gen.h"

#include <bitset>
#include <set>

#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/command_generic_argument.h"
#include "mongo/db/commands.h"

namespace mongo {
namespace repl {

constexpr StringData ApplyOpsCommandInfoBase::kAllowAtomicFieldName;
constexpr StringData ApplyOpsCommandInfoBase::kAlwaysUpsertFieldName;
constexpr StringData ApplyOpsCommandInfoBase::kOperationsFieldName;
constexpr StringData ApplyOpsCommandInfoBase::kPreConditionFieldName;


ApplyOpsCommandInfoBase::ApplyOpsCommandInfoBase() : _hasOperations(false) {
    // Used for initialization only
}

ApplyOpsCommandInfoBase ApplyOpsCommandInfoBase::parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    ApplyOpsCommandInfoBase object;
    object.parseProtected(ctxt, bsonObject);
    return object;
}
void ApplyOpsCommandInfoBase::parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    std::set<StringData> usedFields;

    for (const auto& element :bsonObject) {
        const auto fieldName = element.fieldNameStringData();

        auto push_result = usedFields.insert(fieldName);
        if (MONGO_unlikely(push_result.second == false)) {
            ctxt.throwDuplicateField(fieldName);
        }

        if (fieldName == kOperationsFieldName) {
            _hasOperations = true;
            std::uint32_t expectedFieldNumber{0};
            const IDLParserErrorContext arrayCtxt(kOperationsFieldName, &ctxt);
            std::vector<mongo::BSONObj> values;

            const BSONObj arrayObject = element.Obj();
            for (const auto& arrayElement : arrayObject) {
                const auto arrayFieldName = arrayElement.fieldNameStringData();
                std::uint32_t fieldNumber;

                Status status = parseNumberFromString(arrayFieldName, &fieldNumber);
                if (status.isOK()) {
                    if (fieldNumber != expectedFieldNumber) {
                        arrayCtxt.throwBadArrayFieldNumberSequence(fieldNumber, expectedFieldNumber);
                    }

                    if (arrayCtxt.checkAndAssertType(arrayElement, Object)) {
                        values.emplace_back(arrayElement.Obj());
                    }
                }
                else {
                    arrayCtxt.throwBadArrayFieldNumberValue(arrayFieldName);
                }
                ++expectedFieldNumber;
            }
            _operations = std::move(values);
        }
        else if (fieldName == kAllowAtomicFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, Bool))) {
                _allowAtomic = element.boolean();
            }
        }
        else if (fieldName == kAlwaysUpsertFieldName) {
            if (MONGO_likely(ctxt.checkAndAssertType(element, Bool))) {
                _alwaysUpsert = element.boolean();
            }
        }
        else if (fieldName == kPreConditionFieldName) {
            std::uint32_t expectedFieldNumber{0};
            const IDLParserErrorContext arrayCtxt(kPreConditionFieldName, &ctxt);
            std::vector<mongo::BSONObj> values;

            const BSONObj arrayObject = element.Obj();
            for (const auto& arrayElement : arrayObject) {
                const auto arrayFieldName = arrayElement.fieldNameStringData();
                std::uint32_t fieldNumber;

                Status status = parseNumberFromString(arrayFieldName, &fieldNumber);
                if (status.isOK()) {
                    if (fieldNumber != expectedFieldNumber) {
                        arrayCtxt.throwBadArrayFieldNumberSequence(fieldNumber, expectedFieldNumber);
                    }

                    if (arrayCtxt.checkAndAssertType(arrayElement, Object)) {
                        values.emplace_back(arrayElement.Obj());
                    }
                }
                else {
                    arrayCtxt.throwBadArrayFieldNumberValue(arrayFieldName);
                }
                ++expectedFieldNumber;
            }
            _preCondition = std::move(values);
        }
    }

    if (MONGO_unlikely(usedFields.find(kOperationsFieldName) == usedFields.end())) {
        ctxt.throwMissingField(kOperationsFieldName);
    }
    if (MONGO_unlikely(usedFields.find(kAllowAtomicFieldName) == usedFields.end())) {
        _allowAtomic = true;
    }
    if (MONGO_unlikely(usedFields.find(kAlwaysUpsertFieldName) == usedFields.end())) {
        _alwaysUpsert = true;
    }

}


void ApplyOpsCommandInfoBase::serialize(BSONObjBuilder* builder) const {
    invariant(_hasOperations);

    {
        builder->append(kOperationsFieldName, _operations);
    }

    builder->append(kAllowAtomicFieldName, _allowAtomic);

    builder->append(kAlwaysUpsertFieldName, _alwaysUpsert);

    if (_preCondition.is_initialized()) {
        builder->append(kPreConditionFieldName, _preCondition.get());
    }

}


BSONObj ApplyOpsCommandInfoBase::toBSON() const {
    BSONObjBuilder builder;
    serialize(&builder);
    return builder.obj();
}

}  // namespace repl
}  // namespace mongo
