/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/fedora --target_arch aarch64 --header build/fedora/mongo/db/s/add_shard_cmd_gen.h --output build/fedora/mongo/db/s/add_shard_cmd_gen.cpp src/mongo/db/s/add_shard_cmd.idl
 */

#include "mongo/platform/basic.h"

#include "mongo/db/s/add_shard_cmd_gen.h"

#include <bitset>
#include <set>

#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/command_generic_argument.h"
#include "mongo/db/commands.h"

namespace mongo {

constexpr StringData ShardIdentity::kClusterIdFieldName;
constexpr StringData ShardIdentity::kConfigsvrConnectionStringFieldName;
constexpr StringData ShardIdentity::kShardNameFieldName;


ShardIdentity::ShardIdentity() : _hasShardName(false), _hasClusterId(false), _hasConfigsvrConnectionString(false) {
    // Used for initialization only
}

ShardIdentity ShardIdentity::parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    ShardIdentity object;
    object.parseProtected(ctxt, bsonObject);
    return object;
}
void ShardIdentity::parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    std::bitset<3> usedFields;
    const size_t kShardNameBit = 0;
    const size_t kClusterIdBit = 1;
    const size_t kConfigsvrConnectionStringBit = 2;

    for (const auto& element :bsonObject) {
        const auto fieldName = element.fieldNameStringData();


        if (fieldName == kShardNameFieldName) {
            if (MONGO_unlikely(usedFields[kShardNameBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kShardNameBit);

            _hasShardName = true;
            if (MONGO_likely(ctxt.checkAndAssertType(element, String))) {
                _shardName = element.str();
            }
        }
        else if (fieldName == kClusterIdFieldName) {
            if (MONGO_unlikely(usedFields[kClusterIdBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kClusterIdBit);

            _hasClusterId = true;
            if (MONGO_likely(ctxt.checkAndAssertType(element, jstOID))) {
                _clusterId = element.OID();
            }
        }
        else if (fieldName == kConfigsvrConnectionStringFieldName) {
            if (MONGO_unlikely(usedFields[kConfigsvrConnectionStringBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kConfigsvrConnectionStringBit);

            _hasConfigsvrConnectionString = true;
            if (MONGO_likely(ctxt.checkAndAssertType(element, String))) {
                _configsvrConnectionString = ConnectionString::deserialize(element.valueStringData());
            }
        }
        else {
            ctxt.throwUnknownField(fieldName);
        }
    }

    if (MONGO_unlikely(!usedFields.all())) {
        if (!usedFields[kShardNameBit]) {
            ctxt.throwMissingField(kShardNameFieldName);
        }
        if (!usedFields[kClusterIdBit]) {
            ctxt.throwMissingField(kClusterIdFieldName);
        }
        if (!usedFields[kConfigsvrConnectionStringBit]) {
            ctxt.throwMissingField(kConfigsvrConnectionStringFieldName);
        }
    }

}


void ShardIdentity::serialize(BSONObjBuilder* builder) const {
    invariant(_hasShardName && _hasClusterId && _hasConfigsvrConnectionString);

    builder->append(kShardNameFieldName, _shardName);

    builder->append(kClusterIdFieldName, _clusterId);

    {
        builder->append(kConfigsvrConnectionStringFieldName, _configsvrConnectionString.toString());
    }

}


BSONObj ShardIdentity::toBSON() const {
    BSONObjBuilder builder;
    serialize(&builder);
    return builder.obj();
}

}  // namespace mongo
