/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/fedora --target_arch aarch64 --header build/fedora/mongo/db/s/add_shard_cmd_gen.h --output build/fedora/mongo/db/s/add_shard_cmd_gen.cpp src/mongo/db/s/add_shard_cmd.idl
 */

#pragma once

#include <algorithm>
#include <boost/optional.hpp>
#include <cstdint>
#include <string>
#include <tuple>
#include <vector>

#include "mongo/base/data_range.h"
#include "mongo/base/string_data.h"
#include "mongo/bson/bsonobj.h"
#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/client/connection_string.h"
#include "mongo/db/namespace_string.h"
#include "mongo/idl/idl_parser.h"
#include "mongo/rpc/op_msg.h"
#include "mongo/util/uuid.h"

namespace mongo {

/**
 * Contains all the information needed to identify a shard and lookup the shard identity document from storage
 */
class ShardIdentity {
public:
    static constexpr auto kClusterIdFieldName = "clusterId"_sd;
    static constexpr auto kConfigsvrConnectionStringFieldName = "configsvrConnectionString"_sd;
    static constexpr auto kShardNameFieldName = "shardName"_sd;

    ShardIdentity();

    static ShardIdentity parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);
    void serialize(BSONObjBuilder* builder) const;
    BSONObj toBSON() const;

    /**
     * The name of the shard
     */
    const StringData getShardName() const& { return _shardName; }
    void getShardName() && = delete;
    void setShardName(StringData value) & { _shardName = value.toString(); _hasShardName = true; }

    /**
     * The unique identifier of the cluster
     */
    const mongo::OID& getClusterId() const { return _clusterId; }
    void setClusterId(mongo::OID value) & { _clusterId = std::move(value); _hasClusterId = true; }

    /**
     * Connection string to the config server
     */
    const mongo::ConnectionString& getConfigsvrConnectionString() const { return _configsvrConnectionString; }
    void setConfigsvrConnectionString(mongo::ConnectionString value) & { _configsvrConnectionString = std::move(value); _hasConfigsvrConnectionString = true; }

protected:
    void parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject);

private:
    std::string _shardName;
    mongo::OID _clusterId;
    mongo::ConnectionString _configsvrConnectionString;
    bool _hasShardName : 1;
    bool _hasClusterId : 1;
    bool _hasConfigsvrConnectionString : 1;
};

}  // namespace mongo
