/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/fedora --target_arch aarch64 --header build/fedora/mongo/db/transactions_stats_gen.h --output build/fedora/mongo/db/transactions_stats_gen.cpp src/mongo/db/transactions_stats.idl
 */

#include "mongo/platform/basic.h"

#include "mongo/db/transactions_stats_gen.h"

#include <bitset>
#include <set>

#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/command_generic_argument.h"
#include "mongo/db/commands.h"

namespace mongo {

constexpr StringData TransactionsStats::kCurrentActiveFieldName;
constexpr StringData TransactionsStats::kCurrentInactiveFieldName;
constexpr StringData TransactionsStats::kCurrentOpenFieldName;
constexpr StringData TransactionsStats::kRetriedCommandsCountFieldName;
constexpr StringData TransactionsStats::kRetriedStatementsCountFieldName;
constexpr StringData TransactionsStats::kTotalAbortedFieldName;
constexpr StringData TransactionsStats::kTotalCommittedFieldName;
constexpr StringData TransactionsStats::kTotalStartedFieldName;
constexpr StringData TransactionsStats::kTransactionsCollectionWriteCountFieldName;


TransactionsStats::TransactionsStats()  {
    // Used for initialization only
}

TransactionsStats TransactionsStats::parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    TransactionsStats object;
    object.parseProtected(ctxt, bsonObject);
    return object;
}
void TransactionsStats::parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    std::bitset<9> usedFields;
    const size_t kRetriedCommandsCountBit = 0;
    const size_t kRetriedStatementsCountBit = 1;
    const size_t kTransactionsCollectionWriteCountBit = 2;
    const size_t kCurrentActiveBit = 3;
    const size_t kCurrentInactiveBit = 4;
    const size_t kCurrentOpenBit = 5;
    const size_t kTotalAbortedBit = 6;
    const size_t kTotalCommittedBit = 7;
    const size_t kTotalStartedBit = 8;

    for (const auto& element :bsonObject) {
        const auto fieldName = element.fieldNameStringData();


        if (fieldName == kRetriedCommandsCountFieldName) {
            if (MONGO_unlikely(usedFields[kRetriedCommandsCountBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kRetriedCommandsCountBit);

            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _retriedCommandsCount = element._numberLong();
            }
        }
        else if (fieldName == kRetriedStatementsCountFieldName) {
            if (MONGO_unlikely(usedFields[kRetriedStatementsCountBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kRetriedStatementsCountBit);

            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _retriedStatementsCount = element._numberLong();
            }
        }
        else if (fieldName == kTransactionsCollectionWriteCountFieldName) {
            if (MONGO_unlikely(usedFields[kTransactionsCollectionWriteCountBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kTransactionsCollectionWriteCountBit);

            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _transactionsCollectionWriteCount = element._numberLong();
            }
        }
        else if (fieldName == kCurrentActiveFieldName) {
            if (MONGO_unlikely(usedFields[kCurrentActiveBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kCurrentActiveBit);

            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _currentActive = element._numberLong();
            }
        }
        else if (fieldName == kCurrentInactiveFieldName) {
            if (MONGO_unlikely(usedFields[kCurrentInactiveBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kCurrentInactiveBit);

            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _currentInactive = element._numberLong();
            }
        }
        else if (fieldName == kCurrentOpenFieldName) {
            if (MONGO_unlikely(usedFields[kCurrentOpenBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kCurrentOpenBit);

            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _currentOpen = element._numberLong();
            }
        }
        else if (fieldName == kTotalAbortedFieldName) {
            if (MONGO_unlikely(usedFields[kTotalAbortedBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kTotalAbortedBit);

            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _totalAborted = element._numberLong();
            }
        }
        else if (fieldName == kTotalCommittedFieldName) {
            if (MONGO_unlikely(usedFields[kTotalCommittedBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kTotalCommittedBit);

            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _totalCommitted = element._numberLong();
            }
        }
        else if (fieldName == kTotalStartedFieldName) {
            if (MONGO_unlikely(usedFields[kTotalStartedBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kTotalStartedBit);

            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _totalStarted = element._numberLong();
            }
        }
        else {
            ctxt.throwUnknownField(fieldName);
        }
    }

    if (MONGO_unlikely(!usedFields.all())) {
        if (!usedFields[kRetriedCommandsCountBit]) {
            _retriedCommandsCount = 0;
        }
        if (!usedFields[kRetriedStatementsCountBit]) {
            _retriedStatementsCount = 0;
        }
        if (!usedFields[kTransactionsCollectionWriteCountBit]) {
            _transactionsCollectionWriteCount = 0;
        }
        if (!usedFields[kCurrentActiveBit]) {
            _currentActive = 0;
        }
        if (!usedFields[kCurrentInactiveBit]) {
            _currentInactive = 0;
        }
        if (!usedFields[kCurrentOpenBit]) {
            _currentOpen = 0;
        }
        if (!usedFields[kTotalAbortedBit]) {
            _totalAborted = 0;
        }
        if (!usedFields[kTotalCommittedBit]) {
            _totalCommitted = 0;
        }
        if (!usedFields[kTotalStartedBit]) {
            _totalStarted = 0;
        }
    }

}


void TransactionsStats::serialize(BSONObjBuilder* builder) const {
    builder->append(kRetriedCommandsCountFieldName, _retriedCommandsCount);

    builder->append(kRetriedStatementsCountFieldName, _retriedStatementsCount);

    builder->append(kTransactionsCollectionWriteCountFieldName, _transactionsCollectionWriteCount);

    builder->append(kCurrentActiveFieldName, _currentActive);

    builder->append(kCurrentInactiveFieldName, _currentInactive);

    builder->append(kCurrentOpenFieldName, _currentOpen);

    builder->append(kTotalAbortedFieldName, _totalAborted);

    builder->append(kTotalCommittedFieldName, _totalCommitted);

    builder->append(kTotalStartedFieldName, _totalStarted);

}


BSONObj TransactionsStats::toBSON() const {
    BSONObjBuilder builder;
    serialize(&builder);
    return builder.obj();
}

}  // namespace mongo
