/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/fedora --target_arch aarch64 --header build/fedora/mongo/db/session_txn_record_gen.h --output build/fedora/mongo/db/session_txn_record_gen.cpp src/mongo/db/session_txn_record.idl
 */

#include "mongo/platform/basic.h"

#include "mongo/db/session_txn_record_gen.h"

#include <bitset>
#include <set>

#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/command_generic_argument.h"
#include "mongo/db/commands.h"

namespace mongo {

constexpr StringData SessionTxnRecord::kLastWriteDateFieldName;
constexpr StringData SessionTxnRecord::kLastWriteOpTimeFieldName;
constexpr StringData SessionTxnRecord::kSessionIdFieldName;
constexpr StringData SessionTxnRecord::kTxnNumFieldName;


SessionTxnRecord::SessionTxnRecord() : _txnNum(-1), _hasSessionId(false), _hasTxnNum(false), _hasLastWriteOpTime(false), _hasLastWriteDate(false) {
    // Used for initialization only
}

SessionTxnRecord SessionTxnRecord::parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    SessionTxnRecord object;
    object.parseProtected(ctxt, bsonObject);
    return object;
}
void SessionTxnRecord::parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    std::set<StringData> usedFields;

    for (const auto& element :bsonObject) {
        const auto fieldName = element.fieldNameStringData();

        auto push_result = usedFields.insert(fieldName);
        if (MONGO_unlikely(push_result.second == false)) {
            ctxt.throwDuplicateField(fieldName);
        }

        if (fieldName == kSessionIdFieldName) {
            _hasSessionId = true;
            if (MONGO_likely(ctxt.checkAndAssertType(element, Object))) {
                IDLParserErrorContext tempContext(kSessionIdFieldName, &ctxt);
                const auto localObject = element.Obj();
                _sessionId = mongo::LogicalSessionId::parse(tempContext, localObject);
            }
        }
        else if (fieldName == kTxnNumFieldName) {
            _hasTxnNum = true;
            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _txnNum = element._numberLong();
            }
        }
        else if (fieldName == kLastWriteOpTimeFieldName) {
            _hasLastWriteOpTime = true;
            if (MONGO_likely(ctxt.checkAndAssertType(element, Object))) {
                const BSONObj localObject = element.Obj();
                _lastWriteOpTime = repl::OpTime::parse(localObject);
            }
        }
        else if (fieldName == kLastWriteDateFieldName) {
            _hasLastWriteDate = true;
            if (MONGO_likely(ctxt.checkAndAssertType(element, Date))) {
                _lastWriteDate = element.date();
            }
        }
    }

    if (MONGO_unlikely(usedFields.find(kSessionIdFieldName) == usedFields.end())) {
        ctxt.throwMissingField(kSessionIdFieldName);
    }
    if (MONGO_unlikely(usedFields.find(kTxnNumFieldName) == usedFields.end())) {
        ctxt.throwMissingField(kTxnNumFieldName);
    }
    if (MONGO_unlikely(usedFields.find(kLastWriteOpTimeFieldName) == usedFields.end())) {
        ctxt.throwMissingField(kLastWriteOpTimeFieldName);
    }
    if (MONGO_unlikely(usedFields.find(kLastWriteDateFieldName) == usedFields.end())) {
        ctxt.throwMissingField(kLastWriteDateFieldName);
    }

}


void SessionTxnRecord::serialize(BSONObjBuilder* builder) const {
    invariant(_hasSessionId && _hasTxnNum && _hasLastWriteOpTime && _hasLastWriteDate);

    {
        BSONObjBuilder subObjBuilder(builder->subobjStart(kSessionIdFieldName));
        _sessionId.serialize(&subObjBuilder);
    }

    builder->append(kTxnNumFieldName, _txnNum);

    {
        const BSONObj localObject = _lastWriteOpTime.toBSON();
        builder->append(kLastWriteOpTimeFieldName, localObject);
    }

    builder->append(kLastWriteDateFieldName, _lastWriteDate);

}


BSONObj SessionTxnRecord::toBSON() const {
    BSONObjBuilder builder;
    serialize(&builder);
    return builder.obj();
}

}  // namespace mongo
